<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2008 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_0/includes/misc.php $
 * $Id: misc.php 1360 2009-01-01 21:27:41Z Quietust $
 */

if (!defined('IN_GAME') && !defined('IN_TURNS'))
	die("Access denied");

// Special variables used by functions in this file
$notices = '';		// Notices accumulated using notice() and displayed using notices()

// Sends mail - returns 0 for success, >0 for error
function prom_mail ($to, $subj, $msg)
{
	return !mail($to, $subj, $msg, 'From: '. lang('EMAIL_FROM') .' <'. MAIL_VALIDATE .">\nX-Mailer: PHP/". phpversion());
}

// fetches a field from the posted form, trims whitespace
function getFormVar ($var, $default = '')
{
	if (isset($_REQUEST[$var]))
		return trim($_REQUEST[$var]);
	else	return $default;
}

// fetches an array from the posted form
function getFormArr ($var, $default = array())
{
	if (isset($_REQUEST[$var]))
		return $_REQUEST[$var];
	else	return $default;
}

// remove any special punctuation (thousands separators), allow positive integers only
function fixInputNum ($num)
{
	$result = floor(unformat_number($num));
	if ($result > 0)
		return $result;
	else	return 0;
}

// remove any special punctuation (thousands separators), allow positive or negative integers
function fixInputNumSigned ($num)
{
	$result = floor(unformat_number($num));
	return $result;
}

// restrict input to a boolean value
function fixInputBool ($bool)
{
	if ($bool)
		return TRUE;
	else	return FALSE;
}

// Prints a message and gracefully ends the current action.
// Use this for pages that need to exit early after having already locked the player record
// All variables used in footer.php MUST be defined as globals
function unavailable ($description)
{
	global $entities, $emp1, $html;
	echo $description .'<br />';

	require(PROM_BASEDIR .'includes/footer.php');
	exit;
}

function notice ($msg)
{
	global $notices;
	if (strlen($notices) > 0)
		$notices .= "<br />\n";
	$notices .= $msg;
}

function notices ($style = 0)
{
	global $notices;
	if (!empty($notices))
	{
		switch ($style)
		{
		case 2:
			echo '<h4 class="cwarn">'. $notices .'</h4>';
			break;
		case 1:
			echo '<h4>'. $notices .'</h4>';
			break;
		case 0:
		default:
			echo $notices .'<hr />';
			break;
		}
		$notices = '';
	}
}

function set_cookie ($name, $value)
{
	setcookie($name, $value);
	$_COOKIE[$name] = $value;
}

function unset_cookie ($name)
{
	setcookie($name, FALSE);
	unset($_COOKIE[$name]);
}

function redirect ($newurl)
{
	header('Location: '. $newurl);
	exit;
}

function validate_email ($email)
{
	return preg_match('/[a-z0-9!#$%&\'*+\/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&\'*+\/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/i', $email);
}

function validate_url ($url)
{
	return preg_match('/https?:\/\/(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?(\/[^\s]*)?/i', $url);
}
?>
