<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2008 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_0/lang/en-US/guide/clanmanage.php $
 * $Id: clanmanage.php 1360 2009-01-01 21:27:41Z Quietust $
 */

if (!defined('IN_GUIDE'))
	die('Access denied');

if (CLAN_ENABLE)
	guidepage($topic, 'clanmanage', 'g_clanmanage', 'Managing your Clan');
function g_clanmanage()
{
	global $era;
?>
<h2>Clan Management</h2>
<p>If you create a clan or are granted appropriate permissions, you may browse here from the Clan page to manage your clan.</p>
<h3>Relations</h3>
<p>From this section, you may request alliances or declare wars with other clans at your own discretion. Any existing relations will be listed with appropriate options to change them, if available.</p>
<p>Be aware that any relation changes will result in a notification being sent to the leaders of the clans involved, and that once you take an action, you must wait before attempting to change your mind.</p>
<h4>Alliances</h4>
<p>By forming an alliance with another clan, your clan members will be allowed to send an unlimited amount of foreign aid shipments to members of your ally clan. You will also be prevented from attacking members of ally clans, as such an incident would be quite embarrassing.</p>
<p>Once you request an alliance with another clan, an appropriate leader of the other clan must accept it before it will take effect. Once in effect, either clan can terminate the alliance at will.</p>
<h4>Wars</h4>
<p>Declaring war with another clan provides several tactical advantages when attacking or casting spells on its members: relative size differences are ignored, <?if (MAX_ATTACKS > 0) echo 'attack limits are bypassed, ';?> and a 20% offensive power bonus is granted.</p>
<p>Be warned that, by declaring war with another clan, the other clan will automatically be placed at war with you as well, immediately giving them the same advantages against you.</p>
<p>Only the clan which began the war can propose a treaty to end it, at which point originating clan members are no longer considered to be at war while enemy clan members are still considered hostile; if the other clan accepts, the war ends, but if the other clan refuses, then it will be as if they had declared war on your clan - now, only they will be able to propose peace.</p>
<h3>Member Permissions</h3>
<p>From this section, a clan's Leader or Assistant Leader can assign special roles to other clan members.</p>
<p>The "Leader" role is allowed to perform any action in the clan - relations can be changed, roles assigned, and clan properties edited.</p>
<p>The "Assistant Leader" role has many of the same privileges, excepting that he cannot change his own role or the role of Leader.</p>
<p>The two "Minister of Foreign Affair" roles are permitted only to change relations and post clan news.</p>
<h3>Clan Properties</h3>
<p>From this section, a clan's password, title, logo image, and homepage location can be changed.</p>
<?
}
?>
