<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2008 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_0/pages/admin/locks.php $
 * $Id: locks.php 1360 2009-01-01 21:27:41Z Quietust $
 */

if (!defined('IN_GAME'))
	die('Access denied');

// This page is extremely stripped down, since it cannot write anything to the database
// and thus cannot establish a session - it must verify the username and password every time
$html = new prom_html_compact();
$html->begin('ADMIN_LOCKS_TITLE');

function lockname ($id)
{
	if ($id == LOCK_HISTORY)
		return lang('ADMIN_LOCKS_NAME_HISTORY');
	if ($id == LOCK_RESET)
		return lang('ADMIN_LOCKS_NAME_RESET');
	if ($id == LOCK_NEW)
		return lang('ADMIN_LOCKS_NAME_NEW');
	if ($id == LOCK_TURNS)
		return lang('ADMIN_LOCKS_NAME_TURNS');
	return lang('ADMIN_LOCKS_NAME_USER', $id);
}

$access = 0;

// check if they're already logged in - if there are any problems, silently fall back to login form method
if (isset($_COOKIE['prom_user']) && isset($_COOKIE['prom_session'])) do
{
	$user1 = new prom_user($_COOKIE['prom_user']);
	if (!$user1->load())
		break;

	if ($user1->u_session != md5($_COOKIE['prom_session']))
		break;

	setlanguage($user1->u_lang);

	if (!($user1->u_flags & UFLAG_ADMIN))
		break;

	$access = 2;
} while (0);

if ($access == 0) do
{
	$username = getFormVar('lock_username');
	$password = getFormVar('lock_password');

	if ($action == '')
		break;

	if (empty($username))
	{
		notice(lang('INPUT_NEED_USERNAME'));
		break;
	}

	if (empty($password))
	{
		notice(lang('INPUT_NEED_PASSWORD'));
		break;
	}

	$user1 = new prom_user();
	if (!$user1->findName($username))
	{
		notice(lang('LOGIN_USER_NOT_FOUND'));
		break;
	}
	if (!$user1->load())
	{
		// this should be impossible if findName() succeeded
		notice(lang('LOGIN_USER_NOT_FOUND'));
		break;
	}
	if (!$user1->checkPassword($password))
	{
		notice(lang('INPUT_INCORRECT_PASSWORD'));
		break;
	}
	setlanguage($user1->u_lang);
	if (!($user1->u_flags & UFLAG_ADMIN))
	{
		notice(lang('ERROR_LOGIN_PAGE_PERMISSION'));
		break;
	}
	$access = 1;
} while (0);

if ($action == 'unlock') do
{
	if ($access == 0)
	{
		notice(lang('ERROR_NOT_LOGGED_IN'));
		break;
	}
	$lock_u = getFormArr('lock_u');
	$lock_e = getFormArr('lock_e');
	$lock_c = getFormArr('lock_c');
	$lock_v = getFormArr('lock_v');

	$unlock_u = '';
	$unlock_e = '';
	$unlock_c = '';
	$unlock_v = '';
	foreach ($lock_u as $ent)
	{
		if (strlen($unlock_u))
			$unlock_u .= ',';
		$unlock_u .= fixInputNum($ent);
	}
	foreach ($lock_e as $ent)
	{
		if (strlen($unlock_e))
			$unlock_e .= ',';
		$unlock_e .= fixInputNum($ent);
	}
	foreach ($lock_c as $ent)
	{
		if (strlen($unlock_c))
			$unlock_c .= ',';
		$unlock_c .= fixInputNum($ent);
	}
	foreach ($lock_v as $ent)
	{
		if (strlen($unlock_v))
			$unlock_v .= ',';
		$unlock_v .= fixInputNum($ent);
	}

	if (strlen($unlock_u))
	{
		$q = $db->query('DELETE FROM '. LOCK_TABLE .' WHERE lock_type = '. ENT_USER .' AND lock_id IN ('. $unlock_u .')');
		if (!$q)
		{
			notice(lang('ADMIN_LOCKS_USER_FAIL'));
			break;
		}
		$r = $q->rowCount();
		if ($r > 0)
			notice(lang('ADMIN_LOCKS_USER_SUCCESS', $r));
	}
	if (strlen($unlock_e))
	{
		$q = $db->query('DELETE FROM '. LOCK_TABLE .' WHERE lock_type = '. ENT_EMPIRE .' AND lock_id IN ('. $unlock_e .')');
		if (!$q)
		{
			notice(lang('ADMIN_LOCKS_EMPIRE_FAIL'));
			break;
		}
		$r = $q->rowCount();
		if ($r > 0)
			notice(lang('ADMIN_LOCKS_EMPIRE_SUCCESS', $r));
	}
	if (strlen($unlock_c))
	{
		$q = $db->query('DELETE FROM '. LOCK_TABLE .' WHERE lock_type = '. ENT_CLAN .' AND lock_id IN ('. $unlock_c .')');
		if (!$q)
		{
			notice(lang('ADMIN_LOCKS_CLAN_FAIL'));
			break;
		}
		$r = $q->rowCount();
		if ($r > 0)
			notice(lang('ADMIN_LOCKS_CLAN_SUCCESS', $r));
	}
	if (strlen($unlock_v))
	{
		$q = $db->query('DELETE FROM '. LOCK_TABLE .' WHERE lock_type = '. ENT_VARS .' AND lock_id IN ('. $unlock_v .')');
		if (!$q)
		{
			notice(lang('ADMIN_LOCKS_VARS_FAIL'));
			break;
		}
		$r = $q->rowCount();
		if ($r > 0)
			notice(lang('ADMIN_LOCKS_VARS_SUCCESS', $r));
	}
} while (0);

if ($access == 1)
	notice(lang('ADMIN_LOCKS_LOGIN_REMINDER'));

notices();

if ($access)
{
?>
<form method="post" action="?location=admin/locks">
<div>
<input type="hidden" name="action" value="unlock" />
<?
	if ($access == 1)
	{
?>
<?=lang('LABEL_USERNAME')?> <input type="text" name="lock_username" size="8" /><br />
<?=lang('LABEL_PASSWORD')?> <input type="password" name="lock_password" size="8" /><br />
<?
	}
	$cnt = 0;

	// Users
	$q = $db->query('SELECT * FROM '. LOCK_TABLE .' WHERE lock_type = '. ENT_USER);
	$result = $q->fetchAll();
	if (count($result))
	{
		$cnt++;
?>
<table border="1">
<tr><th><?=lang('ADMIN_LOCKS_COLUMN_USER')?></th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_LOCKEDBY')?></th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_LOCKDATE')?>Lock Date</th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_UNLOCK')?></th></tr>
<?		foreach ($result as $ent)
		{ ?>
<tr><td><?=$ent['lock_id']?></td>
    <td><?=lockname($ent['lock_owner'])?></td>
    <td><?=$ent['lock_date']?></td>
    <td><?=checkbox('lock_u[]', '', $ent['lock_id'])?></td></tr>
<?		} ?>
</table>
<?	}

	// Empires
	$q = $db->query('SELECT * FROM '. LOCK_TABLE .' WHERE lock_type = '. ENT_EMPIRE);
	$result = $q->fetchAll();
	if (count($result))
	{
		$cnt++;
?>
<table border="1">
<tr><th><?=lang('ADMIN_LOCKS_COLUMN_EMPIRE')?></th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_LOCKEDBY')?></th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_LOCKDATE')?>Lock Date</th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_UNLOCK')?></th></tr>
<?		foreach ($result as $ent)
		{ ?>
<tr><td><?=$ent['lock_id']?></td>
    <td><?=lockname($ent['lock_owner'])?></td>
    <td><?=$ent['lock_date']?></td>
    <td><?=checkbox('lock_e[]', '', $ent['lock_id'])?></td></tr>
<?		} ?>
</table>
<?	}

	// Clans
	$q = $db->query('SELECT * FROM '. LOCK_TABLE .' WHERE lock_type = '. ENT_CLAN);
	$result = $q->fetchAll();
	if (count($result))
	{
		$cnt++;
?>
<table border="1">
<tr><th><?=lang('ADMIN_LOCKS_COLUMN_CLAN')?></th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_LOCKEDBY')?></th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_LOCKDATE')?>Lock Date</th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_UNLOCK')?></th></tr>
<?		foreach ($result as $ent)
		{ ?>
<tr><td><?=$ent['lock_id']?></td>
    <td><?=lockname($ent['lock_owner'])?></td>
    <td><?=$ent['lock_date']?></td>
    <td><?=checkbox('lock_c[]', '', $ent['lock_id'])?></td></tr>
<?		} ?>
</table>
<?	}

	// Vars
	$q = $db->query('SELECT * FROM '. LOCK_TABLE .' WHERE lock_type = '. ENT_VARS);
	$result = $q->fetchAll();
	if (count($result))
	{
		$cnt++;
?>
<table border="1">
<tr><th><?=lang('ADMIN_LOCKS_COLUMN_VARS')?></th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_LOCKEDBY')?></th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_LOCKDATE')?>Lock Date</th>
    <th><?=lang('ADMIN_LOCKS_COLUMN_UNLOCK')?></th></tr>
<?		foreach ($result as $ent)
		{ ?>
<tr><td><?=$ent['lock_id']?></td>
    <td><?=lockname($ent['lock_owner'])?></td>
    <td><?=$ent['lock_date']?></td>
    <td><?=checkbox('lock_v[]', '', $ent['lock_id'])?></td></tr>
<?		} ?>
</table>
<?	}
	if ($cnt == 0)
		echo lang('ADMIN_LOCKS_NONE_FOUND') .'<br />'."\n";
?>
<input type="submit" value="<?=lang(($cnt == 0) ? 'ADMIN_LOCKS_VIEW_SUBMIT' : 'ADMIN_LOCKS_UNLOCK_SUBMIT')?>" />
</div>
</form>
<?
}
else
{
?>
<form method="post" action="?location=admin/locks">
<div>
<input type="hidden" name="action" value="view" />
<?=lang('LABEL_USERNAME')?> <input type="text" name="lock_username" size="8" /><br />
<?=lang('LABEL_PASSWORD')?> <input type="password" name="lock_password" size="8" /><br />
<input type="submit" value="<?=lang('ADMIN_LOCKS_VIEW_SUBMIT')?>" />
</div>
</form>
<?
}
$html->end();
?>
