<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2008 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_0/pages/clan.php $
 * $Id: clan.php 1360 2009-01-01 21:27:41Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'CLAN_TITLE';

// are we joining a clan?
if ($action == 'join')
	$lock['clan1'] = fixInputNum(getFormVar('join_id'));

// no? then try to lock the one we're in (assuming we're in one)
if ($lock['clan1'] == 0)
	$lock['clan1'] = -1;

require(PROM_BASEDIR .'includes/header.php');

if (ROUND_FINISHED)
	unavailable(lang('CLAN_UNAVAILABLE_END'));
if (!ROUND_STARTED)
	unavailable(lang('CLAN_UNAVAILABLE_START'));
if ($emp1->is_protected())
	unavailable(lang('CLAN_UNAVAILABLE_PROTECT'));
if ($emp1->e_flags & EFLAG_ADMIN)
	unavailable(lang('CLAN_UNAVAILABLE_ADMIN'));
if (!CLAN_ENABLE)
	unavailable(lang('CLAN_UNAVAILABLE_CONFIG'));

if ($action == 'create') do
{
	if (ROUND_CLOSING)
	{
		notice(lang('CLAN_CREATE_TOO_LATE'));
		break;
	}
	if ($emp1->c_id)
	{
		notice(lang('CLAN_ALREADY_MEMBER'));
		break;
	}
	if ($emp1->effects->m_clan)
	{
		notice(lang('CLAN_CREATE_TOO_SOON', CLAN_MINREJOIN));
		break;
	}

	$cname = htmlspecialchars(getFormVar('create_name'));
	$cpass = getFormVar('create_pass');
	$cpass_verify = getFormVar('create_pass_verify');
	if (empty($cname))
	{
		notice(lang('CLAN_CREATE_NEED_NAME'));
		break;
	}
	if ($cname == 'None')
	{
		notice(lang('CLAN_CREATE_NAME_INVALID'));
		break;
	}
	if (lang_isset($cname))
	{
		notice(lang('CLAN_CREATE_NAME_INVALID'));
		break;
	}
	if (strlen($cname) > 8)
	{
		notice(lang('CLAN_CREATE_NAME_TOO_LONG'));
		break;
	}
	if (empty($cpass))
	{
		notice(lang('INPUT_NEED_PASSWORD'));
		break;
	}
	if ($cpass != $cpass_verify)
	{
		notice(lang('INPUT_PASSWORD_MISMATCH'));
		break;
	}

	if (sqleval($db, 'SELECT COUNT(*) FROM '. CLAN_TABLE .' WHERE c_name = ? AND c_members >= 0', array($cname)) > 0)
	{
		notice(lang('CLAN_CREATE_NAME_IN_USE'));
		break;
	}

	$clan1 = new prom_clan();
	$clan1->create($emp1, $cname, $cpass);
	$entities[] = $clan1;	// add it to the global entity list so it gets freed at the end of the page
	$lock['clan1'] = $clan1->c_id;

	$emp1->c_id = $clan1->c_id;
	$emp1->effects->m_clan = 3600 * CLAN_MINJOIN;

	addEmpireNews(EMPNEWS_CLAN_CREATE, $emp1, $emp1, 0);
	addClanNews(CLANNEWS_MEMBER_CREATE, $clan1, $emp1);
	notice(lang('CLAN_CREATE_COMPLETE', $cname));
	logevent(varlist(array('cname'), get_defined_vars()));
	$emp1->save(FALSE);	// save clan affiliation
} while (0);
if ($action == 'join') do
{
	if ($emp1->c_id)
	{
		notice(lang('CLAN_ALREADY_MEMBER'));
		break;
	}
	if ($emp1->effects->m_clan)
	{
		notice(lang('CLAN_JOIN_TOO_SOON', CLAN_MINREJOIN));
		break;
	}
	if ($lock['clan1'] == 0)
	{
		notice(lang('CLAN_JOIN_NEED_CLAN'));
		break;
	}

	$cpass = getFormVar('join_pass');
	if (md5($cpass) != $clan1->c_password)
	{
		notice(lang('INPUT_INCORRECT_PASSWORD'));
		break;
	}
	$maxmembers = round(10 + sqleval($db, 'SELECT COUNT(*) FROM '. EMPIRE_TABLE .' WHERE u_id > 0') / 100);
	if ($clan1->c_members >= $maxmembers)
	{
		notice(lang('CLAN_JOIN_IS_FULL'));
		break;
	}

	$emp1->c_id = $clan1->c_id;
	$emp1->e_sharing = 0;
	$emp1->effects->m_clan = 3600 * CLAN_MINJOIN;
	$clan1->c_members++;
	$emp_a = new prom_empire($clan1->e_id_leader);
	$emp_a->loadPartial();
	addEmpireNews(EMPNEWS_CLAN_JOIN, $emp1, $emp_a, 0);	// Send "join" notice to the leader
	addEmpireNews(EMPNEWS_CLAN_JOIN, $emp1, $emp1, 0);	// and to yourself
	addClanNews(CLANNEWS_MEMBER_JOIN, $clan1, $emp1);	// and to the clan itself
	notice(lang('CLAN_JOIN_COMPLETE', $clan1->c_name));
	logevent();
	$emp1->save(FALSE);	// save clan affiliation
	$emp_a = NULL;
} while (0);
if ($action == 'leave') do
{
	if ($emp1->c_id == 0)
	{
		notice(lang('CLAN_NOT_MEMBER'));
		break;
	}
	if ($emp1->effects->m_clan)
	{
		notice(lang('CLAN_LEAVE_TOO_SOON', CLAN_MINJOIN));
		break;
	}
	$confirm = fixInputBool(getFormVar('confirm'));
	if (!$confirm)
	{
		notice(lang('CLAN_LEAVE_NEED_CONFIRM'));
		break;
	}
	if ($clan1->e_id_leader == $emp1->e_id)
	{
		if ($clan1->c_members != 1)
		{
			notice(lang('CLAN_LEAVE_OTHER_MEMBERS'));
			break;
		}
		addEmpireNews(EMPNEWS_CLAN_DISBAND, $emp1, $emp1, 0);
		$emp1->c_id = 0;
		$emp1->e_sharing = 0;
		$emp1->effects->m_clan = 3600 * CLAN_MINREJOIN;
		$clan1->c_members = 0;
		notice(lang('CLAN_LEAVE_COMPLETE_DISBAND', $clan1->c_name));
		logevent('disband');
	}
	else
	{
		if ($clan1->e_id_asst == $emp1->e_id)
			$clan1->e_id_asst = 0;
		if ($clan1->e_id_fa1 == $emp1->e_id)
			$clan1->e_id_fa1 = 0;
		if ($clan1->e_id_fa2 == $emp1->e_id)
			$clan1->e_id_fa2 = 0;
		$clan1->c_members--;
		$emp_a = new prom_empire($clan1->e_id_leader);
		$emp_a->loadPartial();
		addEmpireNews(EMPNEWS_CLAN_LEAVE, $emp1, $emp_a, 0);	// Send "left" notice to the leader
		addEmpireNews(EMPNEWS_CLAN_LEAVE, $emp1, $emp1, 0);	// and to yourself
		addClanNews(CLANNEWS_MEMBER_LEAVE, $clan1, $emp1);	// and to the clan

		$emp1->c_id = 0;
		$emp1->e_sharing = 0;
		$emp1->effects->m_clan = 3600 * CLAN_MINREJOIN;
		notice(lang('CLAN_LEAVE_COMPLETE', $clan1->c_name));
		logevent('leave');
		$emp_a = NULL;
	}
} while (0);
if ($action == 'share') do
{
	if ($emp1->c_id == 0)
	{
		notice(lang('CLAN_NOT_MEMBER'));
		break;
	}
	$emp1->e_sharing = -1;
	addClanNews(CLANNEWS_MEMBER_SHARE, $clan1, $emp1);
	notice(lang('CLAN_SHARE_COMPLETE'));
	logevent();
	$emp1->save(FALSE);	// sharing stats
} while (0);
if ($action == 'unshare') do
{
	if ($emp1->c_id == 0)
	{
		notice(lang('CLAN_NOT_MEMBER'));
		break;
	}
	$emp1->e_sharing = CLAN_MINSHARE * (60 / TURNS_FREQ) - 1;
	addClanNews(CLANNEWS_MEMBER_UNSHARE, $clan1, $emp1);
	notice(lang('CLAN_UNSHARE_COMPLETE', CLAN_MINSHARE));
	logevent();
	$emp1->save(FALSE);	// sharing stats
} while (0);
notices();

if ($emp1->c_id)
{
	if ($clan1->c_url)
	{
?><a href="<?=$clan1->c_url?>" rel="external"><?
	}
	if ($clan1->c_pic)
	{
?><img src="<?=$clan1->c_pic?>" style="border:0" alt="<?=lang('CLAN_LINK_LABEL', $clan1->c_title)?>" /><?
	}
	elseif ($clan1->c_url)
	{
		echo lang('CLAN_LINK_LABEL', $clan1->c_title);
	}
	if ($clan1->c_url)
	{
?></a><?
	}
?>
<br />
<table style="background-color:#1F1F1F">
<tr><th class="era<?=$emp1->e_era?>"><?=lang('CLAN_MEMBER_HEADER', $clan1->c_name)?></th></tr>
</table>
<h3><a href="?location=clanforum"><?=lang('CLAN_LINK_FORUM')?></a></h3>
<?
	if (in_array($emp1->e_id, array($clan1->e_id_leader, $clan1->e_id_asst, $clan1->e_id_fa1, $clan1->e_id_fa2)))
	{
?>
<h3><a href="?location=clanmanage"><?=lang('CLAN_LINK_MANAGE')?></a></h3>
<?
	}
?>
<h3><?=lang('CLAN_RELATIONS_HEADER', $clan1->c_title)?></h3>
<table class="inputtable">
<tr><th style="width:50%"><span class="cgood"><?=lang('CLAN_ALLY_LABEL')?></span><br /><?=lang('CLAN_ALLY_DESC')?></th>
    <th style="width:50%"><span class="cbad"><?=lang('CLAN_WAR_LABEL')?></span><br /><?=lang('CLAN_WAR_DESC')?></th></tr>
<?
	$allies1 = $clan1->listRelations(CRFLAG_ALLY | CRFLAG_MUTUAL, CRFLAG_ALLY | CRFLAG_MUTUAL, RELATION_OUTBOUND | RELATION_INBOUND);
	$allies2 = $clan1->listRelations(CRFLAG_ALLY | CRFLAG_MUTUAL, CRFLAG_ALLY, RELATION_OUTBOUND);
	$allies3 = $clan1->listRelations(CRFLAG_ALLY | CRFLAG_MUTUAL, CRFLAG_ALLY, RELATION_INBOUND);
	$allies = array();
	if (count($allies1) > 0)
	{
		$allies[] = '<b>'. lang('CLAN_ALLY_MUTUAL_LABEL') .'</b>';
		foreach ($allies1 as $id)
			$allies[] = $cnames[$id];
	}
	if (count($allies2) > 0)
	{
		$allies[] = '<b>'. lang('CLAN_ALLY_OUTBOUND_LABEL') .'</b>';
		foreach ($allies2 as $id)
			$allies[] = $cnames[$id];
	}
	if (count($allies3) > 0)
	{
		$allies[] = '<b>'. lang('CLAN_ALLY_INBOUND_LABEL') .'</b>';
		foreach ($allies3 as $id)
			$allies[] = $cnames[$id];
	}
	if (count($allies) == 0)
		$allies[] = '<b>'. lang('CLAN_ALLY_NONE_LABEL') .'</b>';

	$wars1 = $clan1->listRelations(CRFLAG_WAR | CRFLAG_MUTUAL, CRFLAG_WAR | CRFLAG_MUTUAL, RELATION_OUTBOUND | RELATION_INBOUND);
	$wars2 = $clan1->listRelations(CRFLAG_WAR | CRFLAG_MUTUAL, CRFLAG_WAR, RELATION_OUTBOUND);
	$wars3 = $clan1->listRelations(CRFLAG_WAR | CRFLAG_MUTUAL, CRFLAG_WAR, RELATION_INBOUND);
	$wars = array();

	if (count($wars1) > 0)
	{
		$wars[] = '<b>'. lang('CLAN_ALLY_MUTUAL_LABEL') .'</b>';
		foreach ($wars1 as $id)
			$wars[] = $cnames[$id];
	}
	if (count($wars2) > 0)
	{
		$wars[] = '<b>'. lang('CLAN_ALLY_OUTBOUND_LABEL') .'</b>';
		foreach ($wars2 as $id)
			$wars[] = $cnames[$id];
	}
	if (count($wars3) > 0)
	{
		$wars[] = '<b>'. lang('CLAN_ALLY_INBOUND_LABEL') .'</b>';
		foreach ($wars3 as $id)
			$wars[] = $cnames[$id];
	}
	if (count($wars) == 0)
		$wars[] = '<b>'. lang('CLAN_ALLY_NONE_LABEL') .'</b>';

	$lines = max(count($allies), count($wars));
	for ($i = 0; $i < $lines; $i++)
	{
		echo '<tr>';
		if (isset($allies[$i]))
			echo '<td class="ac">'. $allies[$i] .'</td>';
		else	echo '<td></td>';
		if (isset($wars[$i]))
			echo '<td class="ac">'. $wars[$i] .'</td>';
		else	echo '<td></td>';
		echo '</tr>'."\n";
	}
?>
</table>
<br />
<form method="post" action="?location=clan">
<div>
<?
	if ($emp1->e_sharing < 0)
	{ ?>
<input type="hidden" name="action" value="unshare" />
<input type="submit" value="<?=lang('CLAN_UNSHARE_SUBMIT')?>" />
<?	}
	else
	{ ?>
<input type="hidden" name="action" value="share" />
<input type="submit" value="<?=lang('CLAN_SHARE_SUBMIT')?>" />
<?	}
?>
</div>
</form>
<?=lang('CLAN_MEMBERS_HEADER', $clan1->c_title, $clan1->c_members)?><br /><br />
<table class="inputtable">
<caption><b><?=lang('CLAN_MEMBERS_LABEL')?></b></caption>
<tr><th><?=lang('COLUMN_CLANRANK')?></th>
    <th><?=lang('COLUMN_EMPIRE')?></th>
    <th><?=lang('COLUMN_NETWORTH')?></th>
    <th><?=lang('COLUMN_RANK')?></th>
    <th><?=lang('COLUMN_RACE')?></th>
    <th><?=lang('COLUMN_ERA')?></th>
    <th><?=lang('COLUMN_SHARING')?></th></tr>
<?
	$troops = array('trparm', 'trplnd', 'trpfly', 'trpsea');
	$shared = array();
	foreach ($troops as $troop)
		$shared[$troop] = 0;

	$q = $db->prepare('SELECT e_id,e_name,e_sharing,e_rank,e_race,e_era,e_networth,e_trparm,e_trplnd,e_trpfly,e_trpsea FROM '. EMPIRE_TABLE .' WHERE c_id = ?');
	$q->execute(array($clan1->c_id)) or warning('Failed to fetch clan member stats', 0);
	$empires = $q->fetchAll();
	foreach ($empires as $data)
	{
		$emp_a = new prom_empire($data['e_id']);
		$emp_a->initdata($data);
		// need to explicitly load effect data
		$emp_a->effects = new prom_empire_effects($emp_a);
		if ($emp_a->e_sharing != 0)
		{
			foreach ($troops as $troop)
				$shared[$troop] += round($emp_a->getData('e_'.$troop) * 0.10);
		}
?>
<tr><td class="ac"><?
		if ($emp_a->e_id == $clan1->e_id_leader)
			echo lang('CLAN_LEADER_LABEL');
		elseif ($emp_a->e_id == $clan1->e_id_asst)
			echo lang('CLAN_ASSISTANT_LABEL');
		elseif (($emp_a->e_id == $clan1->e_id_fa1) || ($emp_a->e_id == $clan1->e_id_fa2))
			echo lang('CLAN_FA_LABEL');
		else	echo '&nbsp;';
?></td>
    <td class="ac"><?=$emp_a?></td>
    <td class="ar"><?=money($emp_a->e_networth)?></td>
    <td class="ar"><?=prenum($emp_a->e_rank)?></td>
    <td class="ac"><?=$races[$emp_a->e_race]?></td>
    <td class="ac"><span class="<?if (($emp_a->e_era == $emp1->e_era) || ($emp1->effects->m_gate) || ($emp_a->effects->m_gate)) echo 'cgood'; else echo 'cwarn';?>"><?if ($emp1->effects->m_gate) echo '*';?><?=$eras[$emp_a->e_era]?><?if ($emp_a->effects->m_gate) echo '*';?></span></td>
    <td class="ac"><span class="<?if ($emp_a->e_sharing) echo 'cgood">'. lang('COMMON_YES'); else echo 'cbad">'. lang('COMMON_NO');?></span></td></tr>
<?
		$emp_a = NULL;
	}
?>
</table><br />
<?
	if ($emp1->e_sharing)
	{
?>
<table class="inputtable">
<caption><b><?=lang('CLAN_SHARE_HEADER')?><?if ($emp1->e_sharing > 0) echo lang('CLAN_UNSHARE_HEADER', $emp1->e_sharing * TURNS_FREQ);?></b></caption>
<tr><th><?=lang('COLUMN_UNIT')?></th>
    <th><?=lang('COLUMN_SHAREYOU')?></th>
    <th><?=lang('COLUMN_SHARETOTAL')?></th></tr>
<?		foreach ($troops as $troop)
		{ ?>
<tr><th><?=lang($emp1->era->getData($troop))?></th>
    <td class="ar"><?=number(round($emp1->getData('e_'.$troop) * 0.10))?></td>
    <td class="ar"><?=number($shared[$troop])?></td></tr>
<?		} ?>
</table>
<?
	}
	// the leader can only leave if he's the only one
	if (($clan1->e_id_leader == $emp1->e_id) && ($clan1->c_members == 1))
	{
?>
<form method="post" action="?location=clan">
<div>
<input type="hidden" name="action" value="leave" />
<?=checkbox('confirm', lang('CLAN_DISBAND_CONFIRM'))?><br />
<input type="submit" value="<?=lang('CLAN_DISBAND_SUBMIT')?>" />
</div>
</form>
<?
	}
	elseif ($clan1->e_id_leader != $emp1->e_id)
	{
?>
<form method="post" action="?location=clan">
<div>
<input type="hidden" name="action" value="leave" />
<?=checkbox('confirm', lang('CLAN_LEAVE_CONFIRM'))?><br />
<input type="submit" value="<?=lang('CLAN_LEAVE_SUBMIT')?>" />
</div>
</form>
<?
	}
}
else
{
	$q = $db->query('SELECT c_id,c_name,c_title FROM '. CLAN_TABLE .' WHERE c_members > 0 ORDER BY c_id ASC') or warning('Failed to get list of active clan names', 0);
	$clans = $q->fetchAll();
	if (count($clans) > 0)
	{
?>
<?=lang('CLAN_NONMEMBER_HEADER')?><br />
<form method="post" action="?location=clan">
<table class="inputtable">
<tr><th colspan="2"><?=lang('CLAN_JOIN_LABEL')?></th></tr>
<tr><td class="ar"><?=lang('LABEL_CLAN')?></td>
    <td><?
		$clanlist = array();
		foreach ($clans as $clan)
		{
			if ($clan['c_title'])
				$clanlist[$clan['c_id']] = lang('CLAN_JOIN_LABEL_WITH_TITLE', $clan['c_name'], $clan['c_title']);
			else	$clanlist[$clan['c_id']] = $clan['c_name'];
		}
		echo optionlist('join_id', $clanlist);
?></td></tr>
<tr><td class="ar"><?=lang('LABEL_PASSWORD')?></td>
    <td><input type="password" name="join_pass" size="8" /></td></tr>
<tr><td colspan="2" class="ac"><input type="hidden" name="action" value="join" /><input type="submit" value="<?=lang('CLAN_JOIN_SUBMIT')?>" /></td></tr>
</table>
</form>
<hr />
<?
	}
	elseif (!ROUND_CLOSING)
		echo lang('CLAN_JOIN_NONE_AVAILABLE') .'<br />';
	else	echo lang('CLAN_JOIN_NONE_UNAVAILABLE') .'<br />';
	if (!ROUND_CLOSING)
	{
?>
<form method="post" action="?location=clan">
<table class="inputtable">
<tr><th colspan="2"><?=lang('CLAN_CREATE_LABEL')?></th></tr>
<tr><td class="ar"><?=lang('LABEL_CLAN_NAME')?></td>
    <td><input type="text" name="create_name" size="8" maxlength="8" /></td></tr>
<tr><td class="ar"><?=lang('LABEL_PASSWORD')?></td>
    <td><input type="password" name="create_pass" size="8" /></td></tr>
<tr><td class="ar"><?=lang('LABEL_PASSWORD_VERIFY')?></td>
    <td><input type="password" name="create_pass_verify" size="8" /></td></tr>
<tr><td colspan="2" class="ac"><input type="hidden" name="action" value="create" /><input type="submit" value="<?=lang('CLAN_CREATE_SUBMIT')?>" /></td></tr>
</table>
</form>
<?
	}
}
require(PROM_BASEDIR .'includes/footer.php');
?>
