<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2008 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_0/pages/news.php $
 * $Id: news.php 1360 2009-01-01 21:27:41Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'NEWS_TITLE';

require(PROM_BASEDIR .'includes/header.php');
require(PROM_BASEDIR .'includes/magic.php');

$newslimit = 100;
$military = array(
	EMPNEWS_MILITARY_STANDARD => 'MILITARY_TYPE_STANDARD',
	EMPNEWS_MILITARY_SURPRISE => 'MILITARY_TYPE_SURPRISE',
	EMPNEWS_MILITARY_ARM => 'MILITARY_TYPE_ARM',
	EMPNEWS_MILITARY_LND => 'MILITARY_TYPE_LND',
	EMPNEWS_MILITARY_FLY => 'MILITARY_TYPE_FLY',
	EMPNEWS_MILITARY_SEA => 'MILITARY_TYPE_SEA'
);

if ($action == 'search') do
{
	$type = getFormVar('news_type');
	$which = getFormVar('news_which');
	$eid = fixInputNum(getFormVar('news_emp'));
	$cid = fixInputNum(getFormVar('news_clan'));

	$where = '';
	$parms = array();
	if ($type == 'emp')
	{
		if ($eid == 0)
			$where = '1';
		elseif ($which == 'attack')
		{
			$where = 'e_id_src = ?';
			$parms[] = $eid;
		}
		elseif ($which == 'defend')
		{
			$where = 'e_id_dst = ?';
			$parms[] = $eid;
		}
		elseif ($which == 'either')
		{
			$where = '(e_id_src = ? OR e_id_dst = ?)';
			$parms[] = $eid;
			$parms[] = $eid;
		}
		else
		{
			notice(lang('NEWS_INVALID_DATA'));
			break;
		}
	}
	elseif (CLAN_ENABLE && ($type == 'clan'))
	{
		if ($which == 'attack')
		{
			$where = 'c_id_src = ?';
			$parms[] = $cid;
		}
		elseif ($which == 'defend')
		{
			$where = 'c_id_dst = ?';
			$parms[] = $cid;
		}
		elseif ($which == 'either')
		{
			$where = '(c_id_src = ? OR c_id_dst = ?)';
			$parms[] = $cid;
			$parms[] = $cid;
		}
		else
		{
			notice(lang('NEWS_INVALID_DATA'));
			break;
		}
	}
	else
	{
		notice(lang('NEWS_INVALID_TYPE'));
		break;
	}
	$q = $db->prepare('SELECT n_time, n_event, n_d0, '.
			'e_id_src, p1.e_name AS e_name_src, c1.c_name AS c_name_src, p1.e_era AS e_era_src, '.
			'e_id_dst, p2.e_name AS e_name_dst, c2.c_name AS c_name_dst FROM '. EMPIRE_NEWS_TABLE .' '.
			'LEFT OUTER JOIN '. EMPIRE_TABLE .' p1 ON (e_id_src = p1.e_id) '.
			'LEFT OUTER JOIN '. CLAN_TABLE .' c1 ON (c_id_src = c1.c_id) '.
			'LEFT OUTER JOIN '. EMPIRE_TABLE .' p2 ON (e_id_dst = p2.e_id) '.
			'LEFT OUTER JOIN '. CLAN_TABLE .' c2 ON (c_id_dst = c2.c_id) '.
			'WHERE '. $where .' AND ('.
				'(n_event = ? AND (c_id_src = 0 OR c_id_dst = 0 OR c_id_src != c_id_dst OR ?)) OR '.
				'(n_event IN (?,?,?,?,?,?,? , ?,?,?,?,?,?,?))'.	// this MUST match the number of elements in the lists below
			') ORDER BY n_id DESC LIMIT '. $newslimit);
	array_push($parms, EMPNEWS_ATTACH_AID_SEND, ($user1->u_flags & (UFLAG_ADMIN | UFLAG_MOD)) ? 1 : 0);
	array_push($parms, EMPNEWS_MAGIC_SPY, EMPNEWS_MAGIC_BLAST, EMPNEWS_MAGIC_STORM, EMPNEWS_MAGIC_RUNES, EMPNEWS_MAGIC_STRUCT, EMPNEWS_MAGIC_FIGHT, EMPNEWS_MAGIC_STEAL);
	array_push($parms, EMPNEWS_MILITARY_KILL, EMPNEWS_MILITARY_STANDARD, EMPNEWS_MILITARY_SURPRISE, EMPNEWS_MILITARY_ARM, EMPNEWS_MILITARY_LND, EMPNEWS_MILITARY_FLY, EMPNEWS_MILITARY_SEA);
	$q->execute($parms) or warning('Failed to fetch news entries', 0);
	$news = $q->fetchAll();
?>
<h2><?=count($news)?> events matched:</h2>
<table class="inputtable" style="width:90%">
<tr><th>Date/Time</th>
    <th>Attacker</th>
    <th>Event</th>
    <th>Defender</th></tr>
<?
	foreach ($news as $result)
	{
		$emp_a = new prom_empire($result['e_id_src']);
		$emp_a->initdata(array('e_id' => $result['e_id_src'], 'e_name' => $result['e_name_src']));
		$emp_b = new prom_empire($result['e_id_dst']);
		$emp_b->initdata(array('e_id' => $result['e_id_dst'], 'e_name' => $result['e_name_dst']));
?>
<tr><td><?=$user1->date('r', $result['n_time'])?></td>
    <td><?=$emp_a?><?if (CLAN_ENABLE) echo '<br />'. lang('NEWS_CLAN', $result['c_name_src']);?></td>
    <td><?
		switch ($result['n_event'])
		{
		case EMPNEWS_MILITARY_KILL:
			echo lang('NEWS_EVENT_KILLED');
			break;
		case EMPNEWS_MILITARY_STANDARD:
		case EMPNEWS_MILITARY_SURPRISE:
		case EMPNEWS_MILITARY_ARM:
		case EMPNEWS_MILITARY_LND:
		case EMPNEWS_MILITARY_FLY:
		case EMPNEWS_MILITARY_SEA:
			echo lang($military[$result['n_event']]) .'<br />';
			if ($result['n_d0'] > 0)
				echo lang('NEWS_EVENT_TOOK_ACRES', $result['n_d0']);
			else	echo lang('NEWS_EVENT_DEFENDED');
			break;
		
		case EMPNEWS_MAGIC_SPY:
		case EMPNEWS_MAGIC_BLAST:
		case EMPNEWS_MAGIC_STORM:
		case EMPNEWS_MAGIC_RUNES:
		case EMPNEWS_MAGIC_STRUCT:
		case EMPNEWS_MAGIC_STEAL:
			// convert event code to spell name, then translate it for the attacker's era
			echo lang(prom_era::lookup($result['e_era_src'], 'spell_'. $spells[$result['n_event']])).'<br />';
			if ($result['n_d0'] < 0)
				echo lang('NEWS_EVENT_SPELL_FAILED');
			elseif ($result['n_d0'] == 0)
				echo lang('NEWS_EVENT_SPELL_SHIELDED');
			else	echo lang('NEWS_EVENT_SPELL_SUCCESS');
			break;

		case EMPNEWS_MAGIC_FIGHT:
			// convert event code to spell name, then translate it for the attacker's era
			echo lang(prom_era::lookup($result['e_era_src'], 'spell_'. $spells[$result['n_event']])).'<br />';
			if ($result['n_d0'] < 0)
				echo lang('NEWS_EVENT_SPELL_FAILED');
			elseif ($result['n_d0'] == 0)
				echo lang('NEWS_EVENT_DEFENDED');
			else	echo lang('NEWS_EVENT_TOOK_ACRES', $result['n_d0']);
			break;

		case EMPNEWS_ATTACH_AID_SEND:
			echo lang('NEWS_EVENT_AID');
			break;

		default:
			echo lang('NEWS_EVENT_UNKNOWN');
			break;
		}
?></td>
    <td><?=$emp_b?><?if (CLAN_ENABLE) echo '<br />'. lang('NEWS_CLAN', $result['c_name_dst']);?></td></tr>
<tr><td colspan="4"><hr /></td></tr>
<?
		$emp_a = NULL;
		$emp_b = NULL;
	}
?>
</table>
<?
} while (0);
notices();
?>
<form method="post" action="?location=news">
<table class="inputtable">
<tr><th class="al"><?=lang('NEWS_LABEL_SEARCHBY')?></th>
    <td><?=radiobutton('news_which', lang('NEWS_LABEL_ATTACKER'), 'attack')?> <?=radiobutton('news_which', lang('NEWS_LABEL_DEFENDER'), 'defend')?> <?=radiobutton('news_which', lang('NEWS_LABEL_EITHER'), 'either', TRUE)?></td></tr>
<tr><th class="al"><?=radiobutton('news_type', lang('NEWS_LABEL_EMPIRE'), 'emp', TRUE)?></th>
    <td><input type="text" name="news_emp" size="5" /></td></tr>
<?
if (CLAN_ENABLE)
{
?>
<tr><th class="al"><?=radiobutton('news_type', lang('NEWS_LABEL_CLAN'), 'clan')?></th>
    <td><?
$clanlist = array();
foreach ($cnames as $id => $name)
	$clanlist[$id] = $name;
echo optionlist('news_clan', $clanlist);
?></td></tr>
<?
}
?>
<tr><td colspan="2" class="ac"><input type="hidden" name="action" value="search" /><input type="submit" value="<?=lang('NEWS_SUBMIT')?>" /></td></tr>
</table>
</form>
<?
require(PROM_BASEDIR .'includes/footer.php');
?>
