<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2008 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_0/pages/pvtmarketbuy.php $
 * $Id: pvtmarketbuy.php 1360 2009-01-01 21:27:41Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'PVTMARKETBUY_TITLE';

require(PROM_BASEDIR .'includes/header.php');

if (ROUND_FINISHED)
	unavailable(lang('PVTMARKETBUY_UNAVAILABLE_END'));
if (!ROUND_STARTED)
	unavailable(lang('PVTMARKETBUY_UNAVAILABLE_START'));

$types = array('trparm', 'trplnd', 'trpfly', 'trpsea', 'food');
$stores = array('trparm' => 'e_mktarm', 'trplnd' => 'e_mktlnd', 'trpfly' => 'e_mktfly', 'trpsea' => 'e_mktsea', 'food' => 'e_mktfood');

// Calculates the buying price of a military unit
function getCost ($emp, $base)
{
	$cost = $base;
	$costbonus = 1 - (1 - PVTM_SHOPBONUS) * ($emp->e_bldcost / $emp->e_land) + PVTM_SHOPBONUS * ($emp->e_bldcash / $emp->e_land);

	$cost *= $costbonus;
	$cost *= $emp->race->market;
	if ($cost < $base * 0.6)
		$cost = $base * 0.6;
	return round($cost);
}

$costs = array();
$costs['trparm'] = getCost($emp1, PVTM_TRPARM);
$costs['trplnd'] = getCost($emp1, PVTM_TRPLND);
$costs['trpfly'] = getCost($emp1, PVTM_TRPFLY);
$costs['trpsea'] = getCost($emp1, PVTM_TRPSEA);
$costs['food'] = round(PVTM_FOOD);

if ($action == 'buy') do
{
	foreach ($types as $type)
	{
		$amount = fixInputNum(getFormVar('buy_'. $type));
		if ($amount == 0)
			continue;
		$price = $costs[$type];
		$cost = $amount * $price;
		if ($amount > $emp1->getData($stores[$type]))
		{
			notice(lang('PVTMARKETBUY_NOT_ENOUGH_UNITS', $emp1->era->getData($type)));
			continue;
		}
		if ($cost > $emp1->e_cash)
		{
			notice(lang('PVTMARKETBUY_NOT_ENOUGH_MONEY', $emp1->era->getData($type)));
			continue;
		}
		$emp1->e_cash -= $cost;
		$emp1->addData('e_'. $type, $amount);
		$emp1->subData($stores[$type], $amount);
		notice(lang('PVTMARKETBUY_COMPLETE', number($amount), $emp1->era->getData($type), money($cost)));
		logevent(varlist(array('type', 'amount', 'cost'), get_defined_vars()));
	}
} while (0);
notices();
?>
<form method="post" action="?location=pvtmarketbuy">
<table class="inputtable">
<tr><td colspan="3"><a href="?location=pvtmarketbuy"><?=lang('PVTMARKET_LINK_BUY')?></a></td>
    <td colspan="3" class="ar"><a href="?location=pvtmarketsell"><?=lang('PVTMARKET_LINK_SELL')?></a></td></tr>
<tr><th class="al"><?=lang('COLUMN_UNIT')?></th>
    <th class="ar"><?=lang('COLUMN_OWNED')?></th>
    <th class="ar"><?=lang('COLUMN_AVAIL')?></th>
    <th class="ar"><?=lang('COLUMN_PRICE')?></th>
    <th class="ar"><?=lang('COLUMN_CANBUY')?></th>
    <th class="ar"><?=lang('COLUMN_BUY')?></th></tr>
<?
foreach ($types as $type)
{
?>
<tr><td><?=lang($emp1->era->getData($type))?></td>
    <td class="ar"><?=number($emp1->getData('e_'. $type))?></td>
    <td class="ar"><?=number($emp1->getData($stores[$type]))?></td>
    <td class="ar"><?=money($costs[$type])?></td>
    <td class="ar"><?=number(min(floor($emp1->e_cash / $costs[$type]), $emp1->getData($stores[$type])))?></td>
    <td class="ar"><input type="text" name="buy_<?=$type?>" size="8" value="0" /></td></tr>
<?
}
?>
<tr><td colspan="6" class="ac"><input type="hidden" name="action" value="buy" /><input type="submit" value="<?=lang('PVTMARKETBUY_SUBMIT')?>" /></td></tr>
</table>
</form>
<?
require(PROM_BASEDIR .'includes/footer.php');
?>
