<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2008 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_0/pages/pvtmarketsell.php $
 * $Id: pvtmarketsell.php 1360 2009-01-01 21:27:41Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'PVTMARKETSELL_TITLE';

require(PROM_BASEDIR .'includes/header.php');

if (ROUND_FINISHED)
	unavailable(lang('PVTMARKETSELL_UNAVAILABLE_END'));
if (!ROUND_STARTED)
	unavailable(lang('PVTMARKETSELL_UNAVAILABLE_START'));

$types = array('trparm', 'trplnd', 'trpfly', 'trpsea', 'food');
$limits = array('trparm' => 'e_mktperarm', 'trplnd' => 'e_mktperlnd', 'trpfly' => 'e_mktperfly', 'trpsea' => 'e_mktpersea');
$stores = array('trparm' => 'e_mktarm', 'trplnd' => 'e_mktlnd', 'trpfly' => 'e_mktfly', 'trpsea' => 'e_mktsea', 'food' => 'e_mktfood');

// Calculates the selling price of a military unit
function getCost ($emp, $base, $multiplier)
{
	$cost = $base * $multiplier;

	// when selling units, the bonus INCREASES the price, so you can get more for them
	$costbonus = 1 + (1 - PVTM_SHOPBONUS) * ($emp->e_bldcost / $emp->e_land) + PVTM_SHOPBONUS * ($emp->e_bldcash / $emp->e_land);

	$cost *= $costbonus;
	$cost /= $emp->race->market;
	if ($cost > $base * 0.5)
		$cost = $base * 0.5;
	return round($cost);
}

$costs = array();
$costs['trparm'] = getCost($emp1, PVTM_TRPARM, 0.32);
$costs['trplnd'] = getCost($emp1, PVTM_TRPLND, 0.34);
$costs['trpfly'] = getCost($emp1, PVTM_TRPFLY, 0.36);
$costs['trpsea'] = getCost($emp1, PVTM_TRPSEA, 0.38);
$costs['food'] = round(PVTM_FOOD * 0.20);

if ($action == 'sell') do
{
	foreach ($types as $type)
	{
		$amount = fixInputNum(getFormVar('sell_'. $type));
		if ($amount == 0)
			continue;
		$price = $costs[$type];
		$cost = $amount * $price;
		if (isset($limits[$type]) && ($amount > (PVTM_MAXSELL - $emp1->getData($limits[$type])) / 10000 * $emp1->getData('e_'. $type)))
		{
			notice(lang('PVTMARKETSELL_TOO_MANY_UNITS', $emp1->era->getData($type)));
			continue;
		}
		if (!isset($limits[$type]) && ($amount > $emp1->getData('e_'. $type)))
		{
			notice(lang('PVTMARKETSELL_NOT_ENOUGH_UNITS', $emp1->era->getData($type)));
			continue;
		}
		$emp1->e_cash += $cost;
		if (isset($limits[$type]))
			$emp1->addData($limits[$type], ($amount / $emp1->getData('e_'. $type)) * 10000);
		$emp1->subData('e_'. $type, $amount);
//		$emp1->addData($stores[$type], $amount);	// allow items to be bought back
		notice(lang('PVTMARKETSELL_COMPLETE', number($amount), $emp1->era->getData($type), money($cost)));
		logevent(varlist(array('type', 'amount', 'cost'), get_defined_vars()));
	}
} while (0);
notices();
?>
<form method="post" action="?location=pvtmarketsell">
<table class="inputtable">
<tr><td colspan="2"><a href="?location=pvtmarketbuy"><?=lang('PVTMARKET_LINK_BUY')?></a></td>
    <td></td>
    <td colspan="2" class="ar"><a href="?location=pvtmarketsell"><?=lang('PVTMARKET_LINK_SELL')?></a></td></tr>
<tr><th class="al"><?=lang('COLUMN_UNIT')?></th>
    <th class="ar"><?=lang('COLUMN_OWNED')?></th>
    <th class="ar"><?=lang('COLUMN_PRICE')?></th>
    <th class="ar"><?=lang('COLUMN_CANSELL')?></th>
    <th class="ar"><?=lang('COLUMN_SELL')?></th></tr>
<?
foreach ($types as $type)
{
?>
<tr><td><?=lang($emp1->era->getData($type))?></td>
    <td class="ar"><?=number($emp1->getData('e_'. $type))?></td>
    <td class="ar"><?=money($costs[$type])?></td>
    <td class="ar"><?if ($type == 'food') echo number($emp1->getData('e_'. $type)); else echo number(floor((PVTM_MAXSELL - $emp1->getData($limits[$type])) / 10000 * $emp1->getData('e_'. $type)));?></td>
    <td class="ar"><input type="text" name="sell_<?=$type?>" size="8" value="0" /></td></tr>
<?
}
?>
<tr><td colspan="6" class="ac"><input type="hidden" name="action" value="sell" /><input type="submit" value="<?=lang('PVTMARKETSELL_SUBMIT')?>" /></td></tr>
</table>
</form>
<?
require(PROM_BASEDIR .'includes/footer.php');
?>
